#include "burner.h"
#include "png.h"

static HWND hNgslotDlg = NULL;
static HWND hParent = NULL;

static HBITMAP hPreview = NULL;
static HBITMAP hPrevBmp = NULL;

static BOOL CALLBACK DefInpProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM /*lParam*/)
{
	switch (Msg) {
		case WM_INITDIALOG: {
			hNgslotDlg = hDlg;
			
			hPreview = LoadBitmap(hAppInst, MAKEINTRESOURCE(BMP_SMALLPREVIEW));
			SendDlgItemMessage(hDlg, IDC_NGSLOT1_IMAGE, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hPreview);
			SendDlgItemMessage(hDlg, IDC_NGSLOT2_IMAGE, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hPreview);
			SendDlgItemMessage(hDlg, IDC_NGSLOT3_IMAGE, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hPreview);
			SendDlgItemMessage(hDlg, IDC_NGSLOT4_IMAGE, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hPreview);
			SendDlgItemMessage(hDlg, IDC_NGSLOT5_IMAGE, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hPreview);
			SendDlgItemMessage(hDlg, IDC_NGSLOT6_IMAGE, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hPreview);
			
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT1_TEXT), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Slot 1"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT1_ROMNAME), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Empty"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT2_TEXT), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Slot 2"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT2_ROMNAME), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Empty"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT3_TEXT), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Slot 3"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT3_ROMNAME), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Empty"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT4_TEXT), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Slot 4"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT4_ROMNAME), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Empty"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT5_TEXT), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Slot 5"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT5_ROMNAME), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Empty"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT6_TEXT), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Slot 6"));
			SendMessage(GetDlgItem(hDlg, IDC_NGSLOT6_ROMNAME), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Empty"));
		
//			IpsManagerInit();

			WndInMid(hDlg, hScrnWnd);
			SetFocus(hDlg);											// Enable Esc=close
			break;
		}
		
		case WM_COMMAND: {
			int wID = LOWORD(wParam);
			int Notify = HIWORD(wParam);
						
			if (Notify == BN_CLICKED) {
				switch (wID) {
					case IDOK: {
//						IpsOkay();
						break;
					}
				
					case IDCANCEL: {
						SendMessage(hDlg, WM_CLOSE, 0, 0);
						return 0;
					}
					
					case IDC_NGSLOT1_SELECT: {
						nNeoSlotDrvNum[0] = SelDialog(1, hDlg);
						if (nNeoSlotDrvNum[0] != (unsigned int)-1) {
							unsigned int nOldDrvSelect = nBurnDrvSelect;
							nBurnDrvSelect = nNeoSlotDrvNum[0];
							TCHAR szText[1024] = _T("");
							_stprintf(szText, _T("%s%s%s%s"), BurnDrvGetText(DRV_NAME), (BurnDrvGetText(DRV_PARENT)) ? _T(" (clone of ") : _T(""), (BurnDrvGetText(DRV_PARENT)) ? BurnDrvGetText(DRV_PARENT) : _T(""), (BurnDrvGetText(DRV_PARENT)) ? _T(")") : _T(""));
							SendMessage(GetDlgItem(hDlg, IDC_NGSLOT1_ROMNAME), WM_SETTEXT, (WPARAM)0, (LPARAM)szText);
							SendMessage(GetDlgItem(hDlg, IDC_NGSLOT1_ROMTITLE), WM_SETTEXT, (WPARAM)0, (LPARAM)BurnDrvGetText(DRV_FULLNAME));
							szText[0] = _T('\0');
							_stprintf(szText, _T("%s, %s"), BurnDrvGetText(DRV_MANUFACTURER), BurnDrvGetText(DRV_DATE));
							SendMessage(GetDlgItem(hDlg, IDC_NGSLOT1_ROMINFO), WM_SETTEXT, (WPARAM)0, (LPARAM)szText);
							nBurnDrvSelect = nOldDrvSelect;
						} else {
							SendMessage(GetDlgItem(hDlg, IDC_NGSLOT1_TEXT), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Slot 1"));
							SendMessage(GetDlgItem(hDlg, IDC_NGSLOT1_ROMNAME), WM_SETTEXT, (WPARAM)0, (LPARAM)_T("Empty"));
						}
						break;
					}
				}
			}
			break;
		}
		
		case WM_CLOSE: {
			EndDialog(hDlg, 0);
			break;
		}
	}

	return 0;
}

int NeogeoSlotSelectCreate(HWND hParentWND)
{
	hParent = hParentWND;
	
	FBADialogBox(hAppInst, MAKEINTRESOURCE(IDD_NGSLOTSELECT), hParent, DefInpProc);
	return 1;
}
